<template>
  <div>
    <div class="flex w-10">
      <button @click="previousPage" class="mr-6 focus:outline-none">
        {{ btnPrevious }}
      </button>
      <span
        :class="{ 'border-blue-400': page === currentPage }"
        class="mr-6 border-b border-solid focus:outline-none"
        v-for="page in pageNumber"
        :key="page"
      >
        {{ page }}
      </span>
      <button @click="nextPage" class="focus:outline-none">
        {{ btnNext }}
      </button>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator";

@Component({
  components: {},
})
export default class Paginate extends Vue {
  @Prop({ default: 4 }) pageNumber!: number;
  @Prop({ default: 5 }) range!: number;
  @Prop({ default: "Previous" }) btnPrevious!: string;
  @Prop({ default: "Next" }) btnNext!: string;
  private currentPage = 1;

  private nextPage() {
    this.currentPage++;

    if (this.currentPage >= this.pageNumber) this.currentPage = this.pageNumber;

    this.$emit("next", this.range);
  }

  private previousPage() {
    this.currentPage--;

    if (this.currentPage <= 1) this.currentPage = 1;

    this.$emit("previous", this.range);
  }
}
</script>
